var fixedSrc = '';
var oldHistoryLength = 0;
var loadCount = 0;

function checkFrameSrc() {
    if (document.getElementById('frame2').src != fixedSrc || history.length != oldHistoryLength) {
        window.location = document.getElementById('frame2').src;
        document.getElementById('menuWrapper').style.display = 'none';
        document.getElementById('frame2').style.margin = '0';
    } else {
        setTimeout("checkFrameSrc()", 2000);
    }
}

function initCheck() {
    fixedSrc = document.getElementById('frame2').src;
    oldHistoryLength = history.length;
    //setTimeout("checkFrameSrc()", 100);
}

function hideFrame(url) {
    document.getElementById('menuWrapper').style.display='none';
    window.location = url;
}

function cram_framed__setFlag(id, flag, hash, flagButton, parentMenuId) {
    new Ajax.Request(
        '/ajax/process_flag_button.ajax.php',
        {
            method: 'get',
            parameters: {
                'id': id,
                'flag': flag,
                'hash': hash
            },
            onSuccess:
                function (resultsTransport) {
                    var updatedScoreMeterWidgetHtml = resultsTransport.responseText;
                    eval(updatedScoreMeterWidgetHtml); // var setFlagResult = {flag, hash,}

                    // @todo: I should bring all this from the ajax request
                    var flagButtonCount = document.getElementById(flag + 'FlagCount');
                    var flagButtonMenuLink = document.getElementById(parentMenuId).getElementsByTagName('a')[0];
                    var flagButtonMenuCount = document.getElementById(parentMenuId + 'TotalFlagCount');
                    var currentFlagCount = parseInt(flagButtonCount.innerHTML.replace("(", ""));
                    var currentTotalFlagCount = parseInt(flagButtonMenuCount.innerHTML.replace("(", ""));

                    var flagCountDelta = setFlagResult.flagIsSetting == 1 ? 1 : -1;
                    currentFlagCount = isNaN(currentFlagCount) ? flagCountDelta : currentFlagCount + flagCountDelta;
                    currentTotalFlagCount = isNaN(currentTotalFlagCount) ? flagCountDelta : currentTotalFlagCount + flagCountDelta;

                    flagButtonCount.innerHTML = currentFlagCount > 0 ? '('+ (currentFlagCount) + ')' : '';
                    flagButtonMenuCount.innerHTML = currentTotalFlagCount > 0 ? '('+ (currentTotalFlagCount) + ')' : '';

                    if (currentFlagCount <= 0) {
                        flagButton.className = flagButton.className.replace('isFlagged', '');
                    } else {
                        flagButton.className += ' isFlagged';
                    }

                    if (currentTotalFlagCount <= 0) {
                        flagButtonMenuLink.className = flagButtonMenuLink.className.replace('isFlagged', '');
                    } else {
                        flagButtonMenuLink.className += ' isFlagged';
                    }
                },
            onFailure:
                function() {
                    alert('Fail!');
                }
        });
    return false;
}

function showHelpPopup() {
    new Effect.Appear('helpPopup');
}

function showSettingsPopup () {
    return false;
}

function showCommentPopup() {
    var elem = document.getElementById('commentPopupWidget');

    //get viewport's width and height
    var vpWidth,vpHeight;
    var x,y;
    if (self.innerHeight) { // all except Explorer
        vpWidth  = self.innerWidth;
        vpHeight = self.innerHeight;
        x = self.pageXOffset;
        y = self.pageYOffset;
    } else if (document.documentElement && document.documentElement.clientHeight) { // Explorer 6 Strict Mode
        vpWidth  = document.documentElement.clientWidth;
        vpHeight = document.documentElement.clientHeight;
        x = document.documentElement.scrollLeft;
        y = document.documentElement.scrollTop;
    } else if (document.body) { // other Explorers
        vpWidth  = document.body.clientWidth;
        vpHeight = document.body.clientHeight;
        x = document.body.scrollLeft;
        y = document.body.scrollTop;
    }

    //get dialog's width and height
    var dialogTop  = (vpHeight/2) - 200;
    var dialogLeft = (vpWidth/2) - 600/2;

    dialogTop = dialogTop + y;

    //Position the Dialog
    elem.style.top  = dialogTop+"px";
    elem.style.left = dialogLeft+"px";

    Effect.Appear('overlay',{duration:0.2, from: 0.0, to: 0.8, queue: 'front'});
    Effect.Appear(elem,{duration:0.5, queue: 'end'});

    return false;
}

function hideCommentPopup () {
    Effect.Fade('commentPopupWidget',{duration:0.5, queue: 'front'});
    Effect.Fade('overlay', {duration: 0.2, from: 0.8, to: 0.0, queue: 'end'});
    return false;
}

function hideBottomBar () {
    $('frame2').setStyle({height: '91%'});
    $('bottomBar').setStyle({display: 'none'});
    return false;
}

// available toolbar features
var availableFeatures = new Array('cramScoreMeter', 'commentWidget', 'votesWidget',
                                  'cramItButton', 'cachesButton', 'proxiesButton', 'relatedButton',
                                  'googleSearchForm');

// map of features to enable/disable based on the viewport's width
// indices of the array represent the width up to which, the specific features are the ones displayed
// order MUST be descendant for this to work properly
// this could come from an ajax request and so we could store this preferences elsewhere (even on a per user basis)
var width2FeaturesMap = {
        "1048":{'cramScoreMeter':1, 'commentWidget':1, 'votesWidget':1,'cramItButton':1, 'cachesButton':1, 'proxiesButton':1, 'relatedButton':1,'googleSearchForm':1},
         "960": {'cramScoreMeter':1, 'commentWidget':1, 'votesWidget':1,'proxiesButton':1, 'cachesButton':1, 'relatedButton':1,'googleSearchForm':1},
         "760": {'cramScoreMeter':1, 'cachesButton':1, 'relatedButton':1, 'googleSearchForm':1},
         "580": {'cramScoreMeter':1, 'googleSearchForm':1
        }
    };


function adjustToolbarForScreenWidth () {
    var viewportWidth = document.viewport.getWidth();
    var useFeatures = new Array();
    // find the right set to use
    // (maybe we could use a switch to improve performance... this is somehow dirty)
    for (var i in width2FeaturesMap) {
        if (!isNaN(parseInt(i))) {
            useFeatures = width2FeaturesMap[i];
            if (viewportWidth >= parseInt(i)) {
                // alert("using set for " + i + " => " + useFeatures.toString());
                break;
            }
        }
    }

    var visibility = "none";
    var i=availableFeatures.length;
    while (i--) {
        visibility = (useFeatures.hasOwnProperty(availableFeatures[i])) ? "block" : "none";
        document.getElementById(availableFeatures[i]).style.display = visibility;
    }
}

/*
  ------------------------------------
  PVII Menu CSS Express Drop-Down Menu
  by Project Seven Development
  www.projectseven.com
  ------------------------------------
*/
function P7_ExpMenu(){ //v1.1.0.2 by PVII-www.projectseven.com
    if(navigator.appVersion.indexOf("MSIE")==-1){return;}
    var i,k,g,lg,r=/\s*hvr/,nn='',c,cs='hvr',bv='menuBar';
    for(i=0;i<10;i++){g=document.getElementById(bv+nn);if(g){
    lg=g.getElementsByTagName("LI");if(lg){for(k=0;k<lg.length;k++){
    lg[k].onmouseover=function(){c=this.className;cl=(c)?c+' '+cs:cs;
    this.className=cl;};lg[k].onmouseout=function(){c=this.className;
    this.className=(c)?c.replace(r,''):'';};}}}nn=i+1;}
}
